<?php

namespace Ulmus\Attribute\Obj;

use Ulmus\Attribute\Attribute;
use Ulmus\Attribute\ConstrainActionEnum;
use Ulmus\Attribute\IndexTypeEnum;

#[\Attribute(\Attribute::TARGET_CLASS | \Attribute::IS_REPEATABLE)]
class Constrain {
    public function __construct(
        public array $columns,
        public null|IndexTypeEnum $type = null,
        public null|string $name = null,
        public null|array|string|\Stringable $foreignKey = null,
        public null|array|string|\Stringable $references = null,
        public ConstrainActionEnum $onDelete = ConstrainActionEnum::NoAction,
        public ConstrainActionEnum $onUpdate = ConstrainActionEnum::NoAction,
    ) {
        $this->foreignKey = Attribute::handleArrayField($this->foreignKey, false);
        $this->references = Attribute::handleArrayField($this->references, false);
    }
}
