<?php

namespace Ulmus\Attribute\Property;

#[\Attribute(\Attribute::TARGET_PROPERTY)]
class Virtual extends Field {

    public bool $readonly = true;

    public function __construct(
        public null|string|array $method = null,
        public ? \Closure $closure = null,
    ) {
        $this->method ??= [ static::class, 'noop' ];
    }

    public static function noop() : null
    {
        return null;
    }
}
